##
## !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
##
##   Ima Student (12345678)
##   CS 231 Spring 2018
##   Assignment 03, Problem 2 
##
## !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
##
##

import check

## mixed_fn(num, action) produces 2*num if action is "double", 
##     num/2 if action is "half", and None otherwise. 
##     If action is "string", the user is prompted to enter a string
##     and then num copies of that string are printed on one line.
##     For any other action, "Invalid action" is printed to the screen.
## Effects: If action is "string", a string is read from standard input, 
##     and copies of the string are printed. For any action other than
##     "string", "half", or "double", "Invalid action" is printed.
## mixed_fn: Int Str -> (anyof Int Float None)
## Requires: num is non-negative
## Examples:
##     mixed_fn(2, "double") => 4
##     mixed_fn(11, "half") => 5.5
##     mixed_fn(6, "oops") => None and prints "Invalid action"
##     mixed_fn(3, "string") => None, if the user inputs "a" 
##         then "aaa" is printed and nothing is produced

def mixed_fn(num,action):
    if action == "double":
        return 2 * num
    elif action == "half":
        return num / 2
    elif action == "string":
        to_print = input("Enter a non-empty string: ")
        print(to_print * num)
    else:
        print("Invalid action")
        
# Test 1: action == "double"
check.expect("Q2T1", mixed_fn(2, "double"), 4)

# Test 2: action == "half", odd number
check.within("Q2T2", mixed_fn(11, "half"), 5.5, .001)

# Test 3: action == "half", even number
check.within("Q2T3", mixed_fn(20, "half"), 10.0, .001)

# Test 4: action == "string"
check.set_input(["hello"])
check.set_screen("hellohellohello")
check.expect("Q2T4", mixed_fn(3, "string"), None)

# Test 5: invalid action
check.set_screen("Invalid action")
check.expect("Q2T5", mixed_fn(2, "DOUBLE"), None)
