##
##   ///////////////////////////////////////////
##   ///    Ima Student (12345678)           ///
##   ///    CS 231 Spring 2018               /// 
##   ///    Assignment 03, Problem 3         ///
##   ///////////////////////////////////////////
##

import check

## file_filter(fname, minimum) opens the file fname, 
##     reads in each integer, and writes each integer > minimum
##     to a new file, "summary.txt". 
## Effects: Reads from the file called fname
##          Writes to the file called "summary.txt" 
## file_filter: String Int -> None
## Requires: 0 <= minimum <= 100
##           fname is the name of a readable file
## Examples:
##     If "ex1.txt" is empty, then file_filter("ex1.txt", 1)
##         will create an empty file named summary.txt
##     If "ex2.txt" contains 35, 75, 50, 90 (one per line), then
##         file_filter("ex2.txt", 50) will create a file
##         named "summary.txt" containing 75, 90 (one per line)

def file_filter(fname, minimum):
    infile = open(fname, "r")
    input_list = infile.readlines()
    infile.close()
    outfile = open("summary.txt", "w")
    for line in input_list:
        if int(line.strip()) > minimum:
            outfile.write(line)
    outfile.close()

# Test 1: empty file (example 1)
check.set_file("summary.txt", "empty.txt")
check.expect("Q3T1", file_filter("empty.txt", 40), None)

# Test 2: example 2
check.set_file("summary.txt", "eg2-summary.txt")
check.expect("Q3T2", file_filter("eg2.txt", 50), None)

# Test 3: file contains one value, it is > minimum
check.set_file("summary.txt", "one-value.txt")
check.expect("Q3T3", file_filter("one-value.txt", 20), None)

# Test 4: file contains one value, it is < minimum
check.set_file("summary.txt", "empty.txt")
check.expect("Q3T4", file_filter("one-value.txt", 80), None)

# Test 5: file contains one value, it equals minimum
check.set_file("summary.txt", "empty.txt")
check.expect("Q3T5", file_filter("one-value.txt", 50), None)

# Test 6: file contains 1-30 on separate lines 
check.set_file("summary.txt", "sixteen-thirty.txt")
check.expect("Q3T6", file_filter("thirty.txt", 15), None)
