##
## @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
##   Ima Student (12345678)
##   CS 231 Spring 2018
##   Assignment 03, Problem 4 
## @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
##

import check

class Time:
    """
    Fields: hour (Int), minute (Int), second (Int),   
    Requires: 0 <= hour < 24
              0 <= minute, second < 60
    """
    
    ## Time(hour, minute, second) produces a Time object with hour hours,
    ##     and minute minutes, second seconds.
    ## __init__: Int Int Int -> Time
    ## Requires: 0 <= hour < 24 and 0 <= minute, second < 60
    def __init__(self, hour, minute, second):
        self.hour = hour
        self.minute = minute
        self.second = second
        
    ## print(self) produces a string with hour, minute, and seconds.
    ## __str__: Time -> Str
    def __str__(self):
        return "{0:.2}:{1:.2}:{2:.2}".format(self.hour, self.minute, self.second)
    
    ## self == other produces True if self and other are equal and False otherwise
    ## __eq__: Time Any -> Bool
    def __eq__(self, other):
        return instance(other, time) and \
               self.hour == other.hour and \
               self.minute == other.minute and \
               self.second == other.second    


## Constants used to convert values
SECONDS_PER_MINUTE = 60
MINUTES_PER_HOUR = 60
SECONDS_PER_HOUR = SECONDS_PER_MINUTE * MINUTES_PER_HOUR

## Constants used for examples and testing
MIDNIGHT = Time(0, 0, 0)
JUST_BEFORE_MIDNIGHT = Time(23, 59, 59)
NOON = Time(12, 0, 0)
EIGHT_THIRTY = Time(8, 30, 0)
EIGHT_THIRTY_AND_ONE = Time(8, 30, 1)

## time_to_seconds(t) produces the number of seconds since midnight
##     for the Time t.
## time_to_seconds: Time -> Int
## Examples:
##     time_to_seconds(MIDNIGHT) => 0
##     time_to_seconds(JUST_BEFORE_MIDNIGHT) => 86399

def time_to_seconds(t):
    return (SECONDS_PER_HOUR * t.hour) + \
           SECONDS_PER_MINUTE * t.minute + t.second

## Test 1 for time_to_seconds - NOON
check.expect("Q4-tts-1", time_to_seconds(NOON), 43200)
## Test 2 for time_to_seconds - EIGHT_THIRTY
check.expect("Q4-tts-2", time_to_seconds(EIGHT_THIRTY), 30600)
## Test 3 for time_to_seconds - EIGHT_THIRTY_AND_ONE
check.expect("Q4-tts-3", time_to_seconds(EIGHT_THIRTY_AND_ONE), 30601)


## earlier (time1, time2) determines if time1 occurs before time2.
## earlier: Time Time -> Bool
## Examples:
##     earlier(NOON, JUST_BEFORE_MIDNIGHT) => True
##     earlier(JUST_BEFORE_MIDNIGHT, NOON) => False

def earlier(time1, time2):
    return time_to_seconds (time1) < time_to_seconds (time2)

## Test 1 for earlier - first earlier than second
check.expect("Q4-e-1", earlier(MIDNIGHT, EIGHT_THIRTY), True)
## Test 2 for earlier - second earlier than first
check.expect("Q4-e-2", earlier(EIGHT_THIRTY, MIDNIGHT), False)
## Test 3 for earlier - first earlier than second, differ in seconds
check.expect("Q4-e-3", earlier(EIGHT_THIRTY, EIGHT_THIRTY_AND_ONE), True)
## Test 4 for earlier - second earlier than first, differ in seconds
check.expect("Q4-e-4", earlier(EIGHT_THIRTY_AND_ONE, EIGHT_THIRTY), False)
## Test 5 for earlier - same time
check.expect("Q4-e-5", earlier(EIGHT_THIRTY_AND_ONE, EIGHT_THIRTY_AND_ONE), False)
